## visp 3.0.1

=== CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. Detect third party libraries (X11, GTK, ...)
#
# Authors:
# Fabien Spindler
#
#############################################################################

# Detect crosscompiling; need to be before project(VISP) to work
if(NOT CMAKE_TOOLCHAIN_FILE)
  # Modify default install prefix
  if(WIN32)
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory")
  endif()
else()
  # Crosscompiling
  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory")
endif()

if(CMAKE_SYSTEM_NAME MATCHES WindowsPhone OR CMAKE_SYSTEM_NAME MATCHES WindowsStore)
  set(WINRT TRUE)
endif(CMAKE_SYSTEM_NAME MATCHES WindowsPhone OR CMAKE_SYSTEM_NAME MATCHES WindowsStore)

if(WINRT)
  add_definitions(-DWINRT)
  
  if(CMAKE_SYSTEM_NAME MATCHES WindowsPhone)
    set(WINRT_PHONE TRUE)
    add_definitions(-DWINRT_PHONE)
  elseif(CMAKE_SYSTEM_NAME MATCHES WindowsStore)
    set(WINRT_STORE TRUE)
    add_definitions(-DWINRT_STORE)
  endif()

  if(CMAKE_SYSTEM_VERSION MATCHES 10 OR CMAKE_SYSTEM_VERSION MATCHES 10.0)
    set(WINRT_10 TRUE)
    add_definitions(-DWINRT_10)
  elseif(CMAKE_SYSTEM_VERSION MATCHES 8.1)
    set(WINRT_8_1 TRUE)
    add_definitions(-DWINRT_8_1)
  elseif(CMAKE_SYSTEM_VERSION MATCHES 8.0)
    set(WINRT_8_0 TRUE)
    add_definitions(-DWINRT_8_0)
  endif()
endif()

# By default set release configuration
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE String "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

project(VISP C CXX)

# Detect if the toolchain is for Aldebaran naoqi
if(CMAKE_TOOLCHAIN_FILE AND I_AM_A_ROBOT)
  include(platforms/naoqi/cmake/extra.cmake)
endif()

cmake_minimum_required(VERSION 2.8.3)

if(POLICY CMP0022)
  cmake_policy(SET CMP0022 NEW) # Due to sensor ATIDAQ_LIBRARIES
endif()

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(cmake/VISPUtils.cmake)

vp_clear_vars(VISPModules_TARGETS)

#-----------------------------------------------------------------------------
# VISP version number.  An even minor number corresponds to releases.
set(VISP_VERSION_MAJOR "3")
set(VISP_VERSION_MINOR "0")
set(VISP_VERSION_PATCH "1")
set(VISP_VERSION "${VISP_VERSION_MAJOR}.${VISP_VERSION_MINOR}.${VISP_VERSION_PATCH}")
# Package revision number
set(VISP_REVISION "1")

find_file(GNU_INSTALL_DIRS_FROM_CMAKE NAMES GNUInstallDirs.cmake PATHS ${CMAKE_ROOT}/Modules)
mark_as_advanced(GNU_INSTALL_DIRS_FROM_CMAKE)
if(GNU_INSTALL_DIRS_FROM_CMAKE)
  include(${CMAKE_ROOT}/Modules/GNUInstallDirs.cmake)
else()
  include(cmake/GNUInstallDirs.cmake)
endif()

#----------------------------------------------------------------------
# Platform specific
#----------------------------------------------------------------------
include(cmake/VISPDetectPlatform.cmake)

# Set the path where to install the lib
if(WIN32)
  if(DEFINED VISP_RUNTIME AND DEFINED VISP_ARCH)
    set(VISP_INSTALL_BINARIES_PREFIX "${VISP_ARCH}/${VISP_RUNTIME}/")
  else()
    message(STATUS "Can't detect runtime and/or arch")
    set(VISP_INSTALL_BINARIES_PREFIX "")
  endif()
else()
  set(VISP_INSTALL_BINARIES_PREFIX "")
endif()

# where to install the library and headers
if(WIN32)
  set(VISP_INC_INSTALL_PATH     ${CMAKE_INSTALL_INCLUDEDIR})
  if(VISP_STATIC)
    set(VISP_LIB_INSTALL_PATH  "${VISP_INSTALL_BINARIES_PREFIX}static${CMAKE_INSTALL_LIBDIR}")
  else()
    set(VISP_LIB_INSTALL_PATH  "${VISP_INSTALL_BINARIES_PREFIX}${CMAKE_INSTALL_LIBDIR}")
  endif()
  set(VISP_BIN_INSTALL_PATH    "${VISP_INSTALL_BINARIES_PREFIX}${CMAKE_INSTALL_BINDIR}")
  set(VISP_3P_LIB_INSTALL_PATH "${VISP_INSTALL_BINARIES_PREFIX}static${CMAKE_INSTALL_LIBDIR}")
else()
  # The location where includes and libraries will be installed

  # The 2 following commented lines should be used to enable multi-arch support.
  # Since catkin doesn't support multi-arch we keep these 2 lines commented for the moment.
  # set(VISP_INC_INSTALL_PATH     ${CMAKE_INSTALL_INCLUDEDIR}/${CMAKE_LIBRARY_ARCHITECTURE})
  # set(VISP_LIB_INSTALL_PATH     ${CMAKE_INSTALL_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE})
  set(VISP_INC_INSTALL_PATH     ${CMAKE_INSTALL_INCLUDEDIR})
  set(VISP_LIB_INSTALL_PATH     ${CMAKE_INSTALL_LIBDIR})
  set(VISP_BIN_INSTALL_PATH     ${CMAKE_INSTALL_BINDIR})
  set(VISP_3P_LIB_INSTALL_PATH  share/ViSP/3rdparty/${VISP_LIB_INSTALL_PATH})
endif()
set(VISP_3P_LIBRARY_OUTPUT_PATH "${VISP_BINARY_DIR}/3rdparty/lib")

# the include directory we depend on for the build
set(VISP_INCLUDE_DIR ${VISP_BINARY_DIR}/${VISP_INC_INSTALL_PATH})
set(VISP_DOC_DIR "${VISP_BINARY_DIR}/doc")

# The location where includes and libraries will be build
set(LIBRARY_OUTPUT_PATH ${VISP_BINARY_DIR}/${VISP_LIB_INSTALL_PATH})
set(BINARY_OUTPUT_PATH ${VISP_BINARY_DIR}/${VISP_BIN_INSTALL_PATH})

if(WIN32)
  # Postfix of .lib and .dll
  set(VISP_DEBUG_POSTFIX "d")
  set(VISP_DLLVERSION "${VISP_VERSION_MAJOR}${VISP_VERSION_MINOR}${VISP_VERSION_PATCH}")
else()
  set(VISP_DEBUG_POSTFIX "")
  set(VISP_DLLVERSION "")
endif()

include_directories(${VISP_INCLUDE_DIR})

#----------------------------------------------------------------------
# SSE optimization
#----------------------------------------------------------------------
VP_OPTION(ENABLE_SSE2  "" "" "Enable SSE2 instructions"  "" ON IF ((MSVC OR CMAKE_COMPILER_IS_GNUCXX) AND (X86 OR X86_64)) )
VP_OPTION(ENABLE_SSE3  "" "" "Enable SSE3 instructions"  "" ON IF ((MSVC OR CMAKE_COMPILER_IS_GNUCXX) AND (X86 OR X86_64)) )
VP_OPTION(ENABLE_SSSE3 "" "" "Enable SSSE3 instructions" "" ON IF ((MSVC OR CMAKE_COMPILER_IS_GNUCXX) AND (X86 OR X86_64)) )

# ----------------------------------------------------------------------------
# Handle always full RPATH
# http://www.cmake.org/Wiki/CMake_RPATH_handling
# ----------------------------------------------------------------------------

# avoid CMP0042 warning
if(APPLE)
  set(CMAKE_MACOSX_RPATH ON)
endif()

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${VISP_LIB_INSTALL_PATH}")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# the RPATH to be used when installing, but only if it's not a system directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${VISP_LIB_INSTALL_PATH}" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${VISP_LIB_INSTALL_PATH}")
endif("${isSystemDir}" STREQUAL "-1")

# ----------------------------------------------------------------------------
#  Path for additional contrib modules
# ----------------------------------------------------------------------------
set(VISP_CONTRIB_MODULES_PATH "" CACHE PATH "Where to look for additional contrib ViSP modules")

# Get the OS
set(OS ${CMAKE_SYSTEM_NAME})

set(OGRE_HOME $ENV{OGRE_HOME})
if(OGRE_HOME)
  # replace \ with / especially for windows
  STRING(REGEX REPLACE "\\\\" "/" OGRE_HOME ${OGRE_HOME}) 
endif()

# add the path to detect Ogre3D
if(WIN32)
  list(APPEND CMAKE_MODULE_PATH "${OGRE_HOME}/CMake")
endif(WIN32)
 
if(UNIX)
  list(APPEND CMAKE_MODULE_PATH "${OGRE_HOME}/cmake")
  list(APPEND CMAKE_MODULE_PATH "${OGRE_HOME}/CMake")
  list(APPEND CMAKE_MODULE_PATH "/usr/local/lib/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/lib/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/local/lib64/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/lib64/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/share/OGRE/cmake/modules")
endif(UNIX)

#--------------------------------------------------------------------
# Option management
#--------------------------------------------------------------------

# Choose static or shared libraries.
VP_OPTION(BUILD_SHARED_LIBS  "" "" "Build ViSP shared libraries (.dll/.so) instead of static ones (.lib/.a)" "" NOT APPLE_FRAMEWORK)
# Build examples as an option.
VP_OPTION(BUILD_EXAMPLES  "" "" "Build ViSP examples" "" ON)
# Build examples as an option.
VP_OPTION(BUILD_TESTS  "" "" "Build ViSP tests" "" ON)
VP_OPTION(BUILD_COVERAGE "" "" "Enables test coverage" "" OFF IF (BUILD_TESTS AND CMAKE_COMPILER_IS_GNUCXX AND CMAKE_BUILD_TYPE MATCHES "Debug"))

# Build demos as an option.
VP_OPTION(BUILD_DEMOS  "" "" "Build ViSP demos" "" ON)
# Build demos as an option.
VP_OPTION(BUILD_TUTORIALS  "" "" "Build ViSP tutorials" "" ON)
# Build deprecated functions as an option.
VP_OPTION(BUILD_DEPRECATED_FUNCTIONS  "" "" "Build deprecated functionalities" "" ON)
# Debug and trace cflags
VP_OPTION(ACTIVATE_DEBUG_TRACE  "" "" "Enable debug and trace printings" "" ON)

VP_OPTION(BUILD_WITH_STATIC_CRT  "" "" "Enables use of staticaly linked CRT for staticaly linked ViSP" "" ON IF MSVC)

# ----------------------------------------------------------------------------
# Build options
# ----------------------------------------------------------------------------
VP_OPTION(ENABLE_SOLUTION_FOLDERS "" "" "Solution folder in Visual Studio or in other IDEs" "" (MSVC_IDE OR CMAKE_GENERATOR MATCHES Xcode))
# Note that it is better to set ENABLE_MOMENTS_COMBINE_MATRICES to OFF
VP_OPTION(ENABLE_MOMENTS_COMBINE_MATRICES  "" "" "Use linear combination of matrices instead of linear combination of moments to compute interaction matrices." "ENABLE_MOMENTS_COMBINE_MATRICES" OFF)
VP_OPTION(ENABLE_TEST_WITHOUT_DISPLAY      "" "" "Don't use display feature when testing" "" ON)
VP_OPTION(ENABLE_FULL_DOC      "" "" "Build doc with internal classes that are by default not part of the doc" "" OFF)

if(ENABLE_SOLUTION_FOLDERS)
  set_property(GLOBAL PROPERTY USE_FOLDERS ON)
  set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")
endif()

if(ENABLE_TEST_WITHOUT_DISPLAY)
  set(OPTION_TO_DESACTIVE_DISPLAY "-d")
endif()

# Check for Inria's robot drivers
VP_CHECK_PACKAGE(RAW1394)
VP_CHECK_PACKAGE(RT)
VP_CHECK_PACKAGE(CALINUX)
VP_CHECK_PACKAGE(IRISA)
# check for linux/parport.h
VP_CHECK_PACKAGE(PARPORT)
# OpenGL
VP_CHECK_PACKAGE(OpenGL)
# for pioneer
VP_CHECK_PACKAGE(RT)
VP_CHECK_PACKAGE(DL)
# for Afma6 calibration data
VP_CHECK_PACKAGE(Afma6_data)
if(AFMA6_DATA_FOUND)
  set(VISP_AFMA6_DATA_PATH ${AFMA6_DATA_PATH})
else()
  set(VISP_AFMA6_DATA_PATH "")
endif()
# for Viper850 calibration data
VP_CHECK_PACKAGE(Viper850_data)
if(VIPER850_DATA_FOUND)
  set(VISP_VIPER850_DATA_PATH ${VIPER850_DATA_PATH})
else()
  set(VISP_VIPER850_DATA_PATH "")
endif()
# for Viper650 calibration data
VP_CHECK_PACKAGE(Viper650_data)
if(VIPER650_DATA_FOUND)
  set(VISP_VIPER650_DATA_PATH ${VIPER650_DATA_PATH})
else()
  set(VISP_VIPER650_DATA_PATH "")
endif()

=== demo/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Nicolas Melchior
#
#############################################################################

project(ViSP-demo)

cmake_minimum_required(VERSION 2.6)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(wireframe-simulator REQUIRED_DEPS visp_core visp_robot visp_vs visp_io visp_gui)

=== example/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(ViSP-examples)

cmake_minimum_required(VERSION 2.6)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(calibration              REQUIRED_DEPS visp_core visp_vision visp_io visp_gui)
visp_add_subdirectory(coin-simulator           REQUIRED_DEPS visp_core visp_robot visp_vs visp_ar visp_io)
visp_add_subdirectory(device/display           REQUIRED_DEPS visp_core visp_gui visp_io)
visp_add_subdirectory(device/framegrabber      REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(device/kinect            REQUIRED_DEPS visp_core visp_sensor visp_gui)
visp_add_subdirectory(device/laserscanner      REQUIRED_DEPS visp_core visp_sensor visp_io)
visp_add_subdirectory(device/light             REQUIRED_DEPS visp_core visp_robot visp_io)
visp_add_subdirectory(direct-visual-servoing   REQUIRED_DEPS visp_core visp_robot visp_visual_features visp_io visp_gui)
visp_add_subdirectory(homography               REQUIRED_DEPS visp_core visp_vision visp_io)
visp_add_subdirectory(image                    REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(key-point                REQUIRED_DEPS visp_core visp_vision visp_sensor visp_io visp_gui)
visp_add_subdirectory(manual                   REQUIRED_DEPS visp_core visp_sensor visp_vs visp_robot visp_ar visp_vision visp_io visp_gui)
visp_add_subdirectory(math                     REQUIRED_DEPS visp_core visp_vision visp_io)
visp_add_subdirectory(moments/image            REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(moments/points           REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(moments/polygon          REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(ogre-simulator           REQUIRED_DEPS visp_core visp_vision visp_ar visp_blob visp_io visp_gui)
visp_add_subdirectory(parse-argv               REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(pose-estimation          REQUIRED_DEPS visp_core visp_blob visp_vision visp_io visp_gui)
visp_add_subdirectory(robot-simulator/afma6    REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(robot-simulator/camera   REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(robot-simulator/viper850 REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(servo-afma4              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-afma6              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(servo-biclops            REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-pioneer            REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-ptu46              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-viper650           REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(servo-viper850           REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(tools                    REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)
visp_add_subdirectory(tracking                 REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(video                    REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(wireframe-simulator      REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)

=== modules/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file.
#
# Authors:
# Fabien Spindler
#
#############################################################################

if(NOT VISP_MODULES_PATH)
  set(VISP_MODULES_PATH "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

# extra modules are outside ViSP. Useful for contrib or specific additional modules
vp_glob_modules(${VISP_MODULES_PATH} EXTRA ${VISP_CONTRIB_MODULES_PATH})

=== tutorial/CMakeLists.txt ===
project(ViSP-tutorial)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(bridge/opencv                 REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(computer-vision               REQUIRED_DEPS visp_core visp_blob visp_vision visp_io visp_gui)
visp_add_subdirectory(grabber                       REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(detection/barcode             REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(detection/face                REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(detection/matching            REQUIRED_DEPS visp_core visp_vision visp_io visp_gui)
visp_add_subdirectory(detection/object              REQUIRED_DEPS visp_core visp_vision visp_mbt visp_io visp_gui)
visp_add_subdirectory(image                         REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(robot/pioneer                 REQUIRED_DEPS visp_core visp_robot visp_vs visp_gui)
visp_add_subdirectory(simulator/image               REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)
visp_add_subdirectory(trace                         REQUIRED_DEPS visp_core)
visp_add_subdirectory(tracking/blob                 REQUIRED_DEPS visp_core visp_blob visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/keypoint             REQUIRED_DEPS visp_core visp_vision visp_klt visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/model-based/generic  REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/stereo   REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/edges    REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/hybrid   REQUIRED_DEPS visp_core visp_mbt visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/keypoint REQUIRED_DEPS visp_core visp_mbt visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/template-tracker     REQUIRED_DEPS visp_core visp_tt visp_io visp_gui)
visp_add_subdirectory(tracking/moving-edges         REQUIRED_DEPS visp_core visp_me visp_io visp_gui visp_sensor)
visp_add_subdirectory(visual-servo/ibvs             REQUIRED_DEPS visp_core visp_robot visp_vs visp_blob visp_vision visp_io visp_gui visp_ar)

=== 3rdparty/libatidaq-c.orig/CMakeLists.txt ===
project(ati)

cmake_minimum_required(VERSION 2.8)

########### already in VISP
# remove all matching elements from the list
macro(vp_list_filterout lst regex)
  foreach(item ${${lst}})
    if(item MATCHES "${regex}")
      list(REMOVE_ITEM ${lst} "${item}")
    endif()
  endforeach()
endmacro()

set(VP_COMPILER_FAIL_REGEX
    "command line option .* is valid for .* but not for C\\+\\+" # GNU
    "command line option .* is valid for .* but not for C" # GNU
    "unrecognized .*option"                     # GNU
    "unknown .*option"                          # Clang
    "ignoring unknown option"                   # MSVC
    "warning D9002"                             # MSVC, any lang
    "option .*not supported"                    # Intel
    "[Uu]nknown option"                         # HP
    "[Ww]arning: [Oo]ption"                     # SunPro
    "command option .* is not recognized"       # XL
    "not supported in this configuration; ignored"       # AIX
    "File with unknown suffix passed to linker" # PGI
    "WARNING: unknown flag:"                    # Open64
  )

macro(vp_check_compiler_flag LANG FLAG RESULT)
  if(NOT DEFINED ${RESULT})
    if("_${LANG}_" MATCHES "_CXX_")
      set(_fname "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/src.cxx")
      if("${CMAKE_CXX_FLAGS} ${FLAG} " MATCHES "-Werror " OR "${CMAKE_CXX_FLAGS} ${FLAG} " MATCHES "-Werror=unknown-pragmas ")
        file(WRITE "${_fname}" "int main() { return 0; }\n")
      else()
        file(WRITE "${_fname}" "#pragma\nint main() { return 0; }\n")
      endif()
    elseif("_${LANG}_" MATCHES "_C_")
      set(_fname "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/src.c")
      if("${CMAKE_C_FLAGS} ${FLAG} " MATCHES "-Werror " OR "${CMAKE_C_FLAGS} ${FLAG} " MATCHES "-Werror=unknown-pragmas ")
        file(WRITE "${_fname}" "int main(void) { return 0; }\n")
      else()
        file(WRITE "${_fname}" "#pragma\nint main(void) { return 0; }\n")
      endif()
    elseif("_${LANG}_" MATCHES "_OBJCXX_")
      set(_fname "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/src.mm")
      if("${CMAKE_CXX_FLAGS} ${FLAG} " MATCHES "-Werror " OR "${CMAKE_CXX_FLAGS} ${FLAG} " MATCHES "-Werror=unknown-pragmas ")
        file(WRITE "${_fname}" "int main() { return 0; }\n")
      else()
        file(WRITE "${_fname}" "#pragma\nint main() { return 0; }\n")
      endif()
    else()
      unset(_fname)
    endif()
    if(_fname)
      message(STATUS "Performing Test ${RESULT}")
      try_compile(${RESULT}
        "${CMAKE_BINARY_DIR}"
        "${_fname}"
        COMPILE_DEFINITIONS "${FLAG}"
        OUTPUT_VARIABLE OUTPUT)

      foreach(_regex ${VP_COMPILER_FAIL_REGEX})
        if("${OUTPUT}" MATCHES "${_regex}")
          set(${RESULT} 0)
          break()
        endif()
      endforeach()

      if(${RESULT})
        set(${RESULT} 1 CACHE INTERNAL "Test ${RESULT}")
        message(STATUS "Performing Test ${RESULT} - Success")
      else()
        message(STATUS "Performing Test ${RESULT} - Failed")
        set(${RESULT} "" CACHE INTERNAL "Test ${RESULT}")
      endif()
    else()
      set(${RESULT} 0)
    endif()
  endif()
endmacro()

macro(vp_check_flag_support lang flag varname)
  if("_${lang}_" MATCHES "_CXX_")
    set(_lang CXX)
  elseif("_${lang}_" MATCHES "_C_")
    set(_lang C)
  else()
    set(_lang ${lang})
  endif()

  string(TOUPPER "${flag}" ${varname})
  string(REGEX REPLACE "^(/|-)" "HAVE_${_lang}_" ${varname} "${${varname}}")
  string(REGEX REPLACE " -|-|=| |\\." "_" ${varname} "${${varname}}")

  vp_check_compiler_flag("${_lang}" "${ARGN} ${flag}" ${${varname}})
endmacro()

# turns off warnings
macro(vp_warnings_disable)
    set(_flag_vars "")
    set(_msvc_warnings "")
    set(_gxx_warnings "")
    foreach(arg ${ARGN})
      if(arg MATCHES "^CMAKE_")
        list(APPEND _flag_vars ${arg})
      elseif(arg MATCHES "^/wd")
        list(APPEND _msvc_warnings ${arg})
      elseif(arg MATCHES "^-W")
        list(APPEND _gxx_warnings ${arg})
      endif()
    endforeach()
    if(MSVC AND _msvc_warnings AND _flag_vars)
      foreach(var ${_flag_vars})
        foreach(warning ${_msvc_warnings})
          set(${var} "${${var}} ${warning}")
        endforeach()
      endforeach()
    elseif((CMAKE_COMPILER_IS_GNUCXX OR ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")) AND _gxx_warnings AND _flag_vars)
      foreach(var ${_flag_vars})
        foreach(warning ${_gxx_warnings})
          if(NOT warning MATCHES "^-Wno-")
            string(REPLACE "${warning}" "" ${var} "${${var}}")
            string(REPLACE "-W" "-Wno-" warning "${warning}")
          endif()
          vp_check_flag_support(${var} "${warning}" _varname)
          if(${_varname})
            set(${var} "${${var}} ${warning}")
          endif()
        endforeach()
      endforeach()
    endif()
    unset(_flag_vars)
    unset(_msvc_warnings)
    unset(_gxx_warnings)
endmacro()


set(ATIDAQ_LIBRARY atidaq)

add_subdirectory(ATIDAQ)

include_directories(${PROJECT_SOURCE_DIR}/ATIDAQ)
#add_executable(ftconvert Samples/ftconvert.c)
#target_link_libraries(ftconvert ${ATIDAQ_LIBRARY})
add_executable(ftconvert test/ftconvert.cpp)
target_link_libraries(ftconvert ${ATIDAQ_LIBRARY})

=== 3rdparty/libatidaq-c/CMakeLists.txt ===
project(${ATIDAQ_LIBRARY})

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB lib_srcs *.c)
file(GLOB lib_hdrs *.h)

vp_list_filterout(lib_srcs xmltok_impl.c)
vp_list_filterout(lib_hdrs xmltok_impl.h)
vp_list_filterout(lib_srcs xmltok_ns.c)
vp_list_filterout(lib_srcs events.c)

add_library(${ATIDAQ_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
endif()

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${ATIDAQ_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

vp_warnings_disable(CMAKE_C_FLAGS -Wunused-parameter)

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${ATIDAQ_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${ATIDAQ_LIBRARY}
  PROPERTIES OUTPUT_NAME ${ATIDAQ_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${ATIDAQ_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${ATIDAQ_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${ATIDAQ_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

=== demo/wireframe-simulator/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(demo-wireframe-simulator)

cmake_minimum_required(VERSION 2.8)

find_package(VISP REQUIRED visp_core visp_robot visp_vs visp_io visp_gui)

# SOURCE variable corresponds to the list of all the sources to build binaries.
# The generate binary comes by removing the .cpp extension to
# the source name.
#
# If you want to add/remove a source, modify here
set(demo_cpp
  servoSimu4Points.cpp
  servoSimuCylinder.cpp
  servoSimuSphere.cpp
)

foreach(cpp ${demo_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "demos")
  endif()
endforeach()

# Add test
# To run some of these tests don't forget to set VISP_INPUT_IMAGE_PATH
# environment variable to the ViSP test sequences location.
# To get these sequence download ViSP-images.tar.gz from
# http://www.irisa.fr/lagadic/visp/visp.html
add_test(servoSimu4Points servoSimu4Points -d)
add_test(servoSimuCylinder servoSimuCylinder -d)
add_test(servoSimuSphere servoSimuSphere -d)

=== example/calibration/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-calibration)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_vision visp_gui visp_io)

set(example_cpp
  camera_calibration.cpp
  calibrateTsai.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()
endforeach()

# Add test
# To run these tests automaticaly using the crontab under Unix or the task
# manager under windows, we have to add the -d option to turn off the display
# of acquired images
add_test(calibrateTsai calibrateTsai)

# copy the data
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/default-chessboard.cfg" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/default-circles.cfg" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-01.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-02.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-03.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-04.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-05.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-01.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-02.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-03.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-04.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-05.png" )

# Copy the data files to the same location than the target
foreach(data ${data2copy})
  visp_copy_data(camera_calibration.cpp ${data})
endforeach()

=== example/coin-simulator/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-coin-simulator)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_robot visp_vs visp_ar visp_io)

set(example_cpp
  simulateFourPoints2DCartesianCamVelocity.cpp
  simulateFourPoints2DPolarCamVelocity.cpp
  simulateCircle2DCamVelocity.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()

  # Add test
  get_filename_component(target ${cpp} NAME_WE)
  add_test(${target} ${target} ${OPTION_TO_DESACTIVE_DISPLAY})
endforeach()

=== example/direct-visual-servoing/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-direct-vvs)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_robot visp_visual_features visp_io visp_gui)

set(example_cpp
  photometricVisualServoing.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()
endforeach()

add_test(photometricVisualServoing photometricVisualServoing -c -n 20 ${OPTION_TO_DESACTIVE_DISPLAY})

=== example/homography/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-homography)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_vision visp_io)

set(example_cpp
  homographyHartleyDLT2DObject.cpp
  homographyHLM2DObject.cpp
  homographyHLM3DObject.cpp
  homographyRansac2DObject.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()

  # Add test
  get_filename_component(target ${cpp} NAME_WE)
  add_test(${target} ${target})
endforeach()

=== debian/changelog ===
visp (3.0.1-2ubuntu2) artful; urgency=medium

  * No-change rebuild with multiarchified lapack.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Sep 2017 08:07:57 +0200

visp (3.0.1-2ubuntu1) artful; urgency=medium

  * Build with -ffloat-store on i386 for correct floating point handling.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Aug 2017 11:29:52 -0700

visp (3.0.1-2build2) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 00:17:13 +0000

visp (3.0.1-2build1) artful; urgency=medium

  * No-change rebuild against OpenCV 3.1.

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Tue, 20 Jun 2017 14:17:40 +0200

visp (3.0.1-2) unstable; urgency=medium

  * Force ctest -j1

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Mon, 13 Feb 2017 17:52:30 +0100

visp (3.0.1-1) unstable; urgency=medium

  * Update watch file
  * Remove 3.0.0 patches
  * New upstream version 3.0.1
  * Update debian material for visp 3.0.1
    - fix lintian warnings ancient-standards-version,
      spelling-error-in-description (duplicate word) vision
    - install module meta header include
    - old visp headers are installed with libvisp-dev to ensure usage when
      all modules are installed
    - install includes in arch triplet
  * Add patches for visp 3.0.1

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Wed, 08 Feb 2017 09:46:36 +0100

=== debian/control ===
Source: visp
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>, Fabien Spindler <Fabien.Spindler@inria.fr>
Section: libs
Priority: extra
Build-Depends: debhelper (>= 9),
	cmake,
	doxygen,
	libopencv-dev,
	liblapack-dev,
	libgsl-dev,
	libcoin80-dev,
	libsoqt4-dev,
	libdc1394-22-dev [linux-any],
	libv4l-dev [!hurd-any],
	libfreenect-dev [!hurd-any !kfreebsd-any],
	libxml2-dev,
	libjpeg-dev,
	libpng-dev,
	libx11-dev,
	libzbar-dev,
	libdmtx-dev,
	libogre-1.9-dev,
	visp-images-data
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/debian-science/packages/visp.git
Vcs-Git: https://anonscm.debian.org/debian-science/packages/visp.git
Homepage: https://visp.inria.fr

Package: libvisp-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-gui-dev (= ${binary:Version}),
	libvisp-io-dev (= ${binary:Version}),
	libvisp-detection-dev (= ${binary:Version}),
	libvisp-ar-dev (= ${binary:Version}),
	libvisp-blob-dev (= ${binary:Version}),
	libvisp-me-dev (= ${binary:Version}),
	libvisp-klt-dev (= ${binary:Version}),
	libvisp-sensor-dev (= ${binary:Version}),
	libvisp-robot-dev (= ${binary:Version}),
	libvisp-visual-features-dev (= ${binary:Version}),
	libvisp-vision-dev (= ${binary:Version}),
	libvisp-vs-dev (= ${binary:Version}),
	libvisp-mbt-dev (= ${binary:Version}),
	libvisp-tt-dev (= ${binary:Version}),
	libvisp-tt-mi-dev (= ${binary:Version})
Suggests: libvisp-doc
Description: development files for ViSP
 This is a metapackage providing development package necessary for
 development of ViSP (Visual Servoing Platform).
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, 
	libvisp-core3.0 (= ${binary:Version}),
	libopencv-dev,
	liblapack-dev,
	libgsl-dev,
	libxml2-dev
Description: development files for libvisp-core
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) core.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: visual servoing platform core library
 This package contains the ViSP (Visual Servoing Platform) core runtime
 libraries.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core3.0-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libvisp-core3.0 (= ${binary:Version})
Description: Debugging symbol for libvisp-core3.0
 This package contains detached debugging symbol for ViSP 
 (Visual Servoing Platform) core library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-gui3.0 (= ${binary:Version}),
	libx11-dev
Description: development files for libvisp-gui
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) graphical user
 interface (GUI) library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.0 (= ${binary:Version})
Description: visual servoing platform gui library
 This package contains the ViSP (Visual Servoing Platform) graphical user
 interface (GUI) runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui3.0-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libvisp-gui3.0 (= ${binary:Version})
Description: Debugging symbol for libvisp-gui3.0
 This package contains detached debugging symbol for ViSP 
 (Visual Servoing Platform) graphical user interface library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-io3.0 (= ${binary:Version}),
	libjpeg-dev,
	libpng-dev
Description: development files for libvisp-io
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) input/output
 (io) library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.0 (= ${binary:Version})
Description: visual servoing platform io library
 This package contains the ViSP (Visual Servoing Platform) input/output
 (io) runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io3.0-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libvisp-io3.0 (= ${binary:Version})
Description: Debugging symbol for libvisp-io3.0
 This package contains detached debugging symbol for ViSP 
 (Visual Servoing Platform) input/output library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-detection-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-detection3.0 (= ${binary:Version}),
	libzbar-dev,
	libdmtx-dev
Description: development files for libvisp-detection
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) detection
 library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-detection3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.0 (= ${binary:Version})
Description: visual servoing platform detection library
 This package contains the ViSP (Visual Servoing Platform) detection
 runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

# Retrieve environment information.
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Linux-specific stuff (dc1394, v4l, ois only available on linux)
ifeq ($(DEB_HOST_ARCH_OS),linux)
  CMAKE_ARCH_FLAGS = -DUSE_DC1394=ON -DUSE_V4L2=ON -DUSE_OIS=ON
else
  CMAKE_ARCH_FLAGS = -DUSE_DC1394=OFF -DUSE_V4L2=OFF -DUSE_OIS=OFF
endif

ifeq ($(DEB_HOST_ARCH),i386)
  CXXFLAGS += -ffloat-store
endif

# freenect is not available on hurd.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
  CMAKE_ARCH_FLAGS += -DUSE_LIBFREENECT=OFF
else
  CMAKE_ARCH_FLAGS += -DUSE_LIBFREENECT=ON
endif

# CMake flags
CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_INSTALL_INCLUDEDIR="include/$(DEB_HOST_MULTIARCH)" \
	-DCMAKE_INSTALL_LIBDIR="lib/$(DEB_HOST_MULTIARCH)" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
	-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_EXE_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_DEMOS=ON \
	-DBUILD_TESTS=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_TUTORIALS=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DUSE_FFMPEG=OFF \
	-DUSE_OPENCV=ON \
	-DUSE_COIN3D=ON \
	-DUSE_LAPACK=ON \
	-DUSE_GSL=ON \
	-DUSE_XML2=ON \
	-DUSE_GTK2=OFF \
	-DUSE_JPEG=ON \
	-DUSE_PNG=ON \
	-DUSE_X11=ON \
	-DUSE_ZBAR=ON \
	-DUSE_DMTX=ON \
	-DUSE_OGRE=ON \
	$(CMAKE_ARCH_FLAGS)

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_clean:
	dh_clean -O--buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_build-indep:
	dh_auto_build -- visp_doc # Generate Doxygen HTML documentation.

override_dh_installdocs:
	dh_installdocs -X.md5

override_dh_strip:
	dh_strip -plibvisp-core3.0 --dbg-package=libvisp-core3.0-dbg
	dh_strip -plibvisp-gui3.0 --dbg-package=libvisp-gui3.0-dbg
	dh_strip -plibvisp-io3.0 --dbg-package=libvisp-io3.0-dbg
	dh_strip -plibvisp-detection3.0 --dbg-package=libvisp-detection3.0-dbg
	dh_strip -plibvisp-ar3.0 --dbg-package=libvisp-ar3.0-dbg
	dh_strip -plibvisp-blob3.0 --dbg-package=libvisp-blob3.0-dbg
	dh_strip -plibvisp-me3.0 --dbg-package=libvisp-me3.0-dbg
	dh_strip -plibvisp-klt3.0 --dbg-package=libvisp-klt3.0-dbg
	dh_strip -plibvisp-sensor3.0 --dbg-package=libvisp-sensor3.0-dbg
	dh_strip -plibvisp-robot3.0 --dbg-package=libvisp-robot3.0-dbg
	dh_strip -plibvisp-visual-features3.0 --dbg-package=libvisp-visual-features3.0-dbg
	dh_strip -plibvisp-vision3.0 --dbg-package=libvisp-vision3.0-dbg
	dh_strip -plibvisp-vs3.0 --dbg-package=libvisp-vs3.0-dbg
	dh_strip -plibvisp-mbt3.0 --dbg-package=libvisp-mbt3.0-dbg
	dh_strip -plibvisp-tt3.0 --dbg-package=libvisp-tt3.0-dbg
	dh_strip -plibvisp-tt-mi3.0 --dbg-package=libvisp-tt-mi3.0-dbg
	dh_strip

# Due to numerical imprecision, some tests are failing on ia64.
# This is not a critical issue so we let the testing fail on this
# architecture for now.
# See http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=723803
ifeq ($(DEB_HOST_ARCH),ia64)
  DH_AUTOTEST_CAN_FAIL=true
else
  DH_AUTOTEST_CAN_FAIL=false
endif

override_dh_auto_test-indep:

# On armel, armhf, i386, mips64el "make -j4 test" fails.
# This is due to the fact that the 4 first tests are trying to create simultaneously
# /usr/$username folder
override_dh_auto_test-arch:
	export VISP_INPUT_IMAGE_PATH=/usr/share/visp-images-data/ \
	 && dh_auto_test --max-parallel=1 || ${DH_AUTOTEST_CAN_FAIL}

# Since Ogre removal no more useful
#override_dh_install:
#ifneq ($(DEB_HOST_ARCH_OS),hurd)
#  ifneq ($(DEB_HOST_ARCH_OS),kfreebsd)
#	# On hurd and kfreebsd usr/lib/*/visp/* is empty and produces an error
#	dh_install "usr/lib/*/visp/*" -p libvisp-dev
#        # Continue with regular dh_install
#	dh_install
#  endif
#endif
